// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Attribute.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ATTRIBUTE__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ATTRIBUTE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_reasoning_msgs/msg/detail/attribute__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Attribute & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: str_value
  {
    out << "str_value: ";
    rosidl_generator_traits::value_to_yaml(msg.str_value, out);
    out << ", ";
  }

  // member: fl_value
  {
    if (msg.fl_value.size() == 0) {
      out << "fl_value: []";
    } else {
      out << "fl_value: [";
      size_t pending_items = msg.fl_value.size();
      for (auto item : msg.fl_value) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Attribute & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: str_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "str_value: ";
    rosidl_generator_traits::value_to_yaml(msg.str_value, out);
    out << "\n";
  }

  // member: fl_value
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fl_value.size() == 0) {
      out << "fl_value: []\n";
    } else {
      out << "fl_value:\n";
      for (auto item : msg.fl_value) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Attribute & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::msg::Attribute & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::msg::Attribute & msg)
{
  return situational_graphs_reasoning_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::msg::Attribute>()
{
  return "situational_graphs_reasoning_msgs::msg::Attribute";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::msg::Attribute>()
{
  return "situational_graphs_reasoning_msgs/msg/Attribute";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::msg::Attribute>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::msg::Attribute>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::msg::Attribute>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ATTRIBUTE__TRAITS_HPP_
