// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_reasoning_msgs/msg/detail/edge__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'information_matrix'
#include "std_msgs/msg/detail/float64_multi_array__traits.hpp"
// Member 'measurement_transform'
#include "geometry_msgs/msg/detail/transform__traits.hpp"
// Member 'attributes'
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Edge & msg,
  std::ostream & out)
{
  out << "{";
  // member: origin_node
  {
    out << "origin_node: ";
    rosidl_generator_traits::value_to_yaml(msg.origin_node, out);
    out << ", ";
  }

  // member: target_node
  {
    out << "target_node: ";
    rosidl_generator_traits::value_to_yaml(msg.target_node, out);
    out << ", ";
  }

  // member: edge_id
  {
    out << "edge_id: ";
    rosidl_generator_traits::value_to_yaml(msg.edge_id, out);
    out << ", ";
  }

  // member: plane_coefficients
  {
    if (msg.plane_coefficients.size() == 0) {
      out << "plane_coefficients: []";
    } else {
      out << "plane_coefficients: [";
      size_t pending_items = msg.plane_coefficients.size();
      for (auto item : msg.plane_coefficients) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: plane_information_matrix
  {
    if (msg.plane_information_matrix.size() == 0) {
      out << "plane_information_matrix: []";
    } else {
      out << "plane_information_matrix: [";
      size_t pending_items = msg.plane_information_matrix.size();
      for (auto item : msg.plane_information_matrix) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: information_matrix
  {
    out << "information_matrix: ";
    to_flow_style_yaml(msg.information_matrix, out);
    out << ", ";
  }

  // member: measurement_transform
  {
    out << "measurement_transform: ";
    to_flow_style_yaml(msg.measurement_transform, out);
    out << ", ";
  }

  // member: attributes
  {
    if (msg.attributes.size() == 0) {
      out << "attributes: []";
    } else {
      out << "attributes: [";
      size_t pending_items = msg.attributes.size();
      for (auto item : msg.attributes) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Edge & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: origin_node
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "origin_node: ";
    rosidl_generator_traits::value_to_yaml(msg.origin_node, out);
    out << "\n";
  }

  // member: target_node
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target_node: ";
    rosidl_generator_traits::value_to_yaml(msg.target_node, out);
    out << "\n";
  }

  // member: edge_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "edge_id: ";
    rosidl_generator_traits::value_to_yaml(msg.edge_id, out);
    out << "\n";
  }

  // member: plane_coefficients
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.plane_coefficients.size() == 0) {
      out << "plane_coefficients: []\n";
    } else {
      out << "plane_coefficients:\n";
      for (auto item : msg.plane_coefficients) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: plane_information_matrix
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.plane_information_matrix.size() == 0) {
      out << "plane_information_matrix: []\n";
    } else {
      out << "plane_information_matrix:\n";
      for (auto item : msg.plane_information_matrix) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: information_matrix
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "information_matrix:\n";
    to_block_style_yaml(msg.information_matrix, out, indentation + 2);
  }

  // member: measurement_transform
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "measurement_transform:\n";
    to_block_style_yaml(msg.measurement_transform, out, indentation + 2);
  }

  // member: attributes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.attributes.size() == 0) {
      out << "attributes: []\n";
    } else {
      out << "attributes:\n";
      for (auto item : msg.attributes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Edge & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::msg::Edge & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::msg::Edge & msg)
{
  return situational_graphs_reasoning_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::msg::Edge>()
{
  return "situational_graphs_reasoning_msgs::msg::Edge";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::msg::Edge>()
{
  return "situational_graphs_reasoning_msgs/msg/Edge";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::msg::Edge>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::msg::Edge>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::msg::Edge>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__TRAITS_HPP_
