// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from situational_graphs_reasoning_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "situational_graphs_reasoning_msgs/msg/detail/edge__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void Edge_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) situational_graphs_reasoning_msgs::msg::Edge(_init);
}

void Edge_fini_function(void * message_memory)
{
  auto typed_message = static_cast<situational_graphs_reasoning_msgs::msg::Edge *>(message_memory);
  typed_message->~Edge();
}

size_t size_function__Edge__plane_coefficients(const void * untyped_member)
{
  (void)untyped_member;
  return 4;
}

const void * get_const_function__Edge__plane_coefficients(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::array<double, 4> *>(untyped_member);
  return &member[index];
}

void * get_function__Edge__plane_coefficients(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::array<double, 4> *>(untyped_member);
  return &member[index];
}

void fetch_function__Edge__plane_coefficients(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const double *>(
    get_const_function__Edge__plane_coefficients(untyped_member, index));
  auto & value = *reinterpret_cast<double *>(untyped_value);
  value = item;
}

void assign_function__Edge__plane_coefficients(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<double *>(
    get_function__Edge__plane_coefficients(untyped_member, index));
  const auto & value = *reinterpret_cast<const double *>(untyped_value);
  item = value;
}

size_t size_function__Edge__plane_information_matrix(const void * untyped_member)
{
  (void)untyped_member;
  return 9;
}

const void * get_const_function__Edge__plane_information_matrix(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::array<double, 9> *>(untyped_member);
  return &member[index];
}

void * get_function__Edge__plane_information_matrix(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::array<double, 9> *>(untyped_member);
  return &member[index];
}

void fetch_function__Edge__plane_information_matrix(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const double *>(
    get_const_function__Edge__plane_information_matrix(untyped_member, index));
  auto & value = *reinterpret_cast<double *>(untyped_value);
  value = item;
}

void assign_function__Edge__plane_information_matrix(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<double *>(
    get_function__Edge__plane_information_matrix(untyped_member, index));
  const auto & value = *reinterpret_cast<const double *>(untyped_value);
  item = value;
}

size_t size_function__Edge__attributes(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<situational_graphs_reasoning_msgs::msg::Attribute> *>(untyped_member);
  return member->size();
}

const void * get_const_function__Edge__attributes(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<situational_graphs_reasoning_msgs::msg::Attribute> *>(untyped_member);
  return &member[index];
}

void * get_function__Edge__attributes(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<situational_graphs_reasoning_msgs::msg::Attribute> *>(untyped_member);
  return &member[index];
}

void fetch_function__Edge__attributes(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const situational_graphs_reasoning_msgs::msg::Attribute *>(
    get_const_function__Edge__attributes(untyped_member, index));
  auto & value = *reinterpret_cast<situational_graphs_reasoning_msgs::msg::Attribute *>(untyped_value);
  value = item;
}

void assign_function__Edge__attributes(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<situational_graphs_reasoning_msgs::msg::Attribute *>(
    get_function__Edge__attributes(untyped_member, index));
  const auto & value = *reinterpret_cast<const situational_graphs_reasoning_msgs::msg::Attribute *>(untyped_value);
  item = value;
}

void resize_function__Edge__attributes(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<situational_graphs_reasoning_msgs::msg::Attribute> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember Edge_message_member_array[8] = {
  {
    "origin_node",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, origin_node),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "target_node",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, target_node),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "edge_id",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_INT64,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, edge_id),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "plane_coefficients",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    4,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, plane_coefficients),  // bytes offset in struct
    nullptr,  // default value
    size_function__Edge__plane_coefficients,  // size() function pointer
    get_const_function__Edge__plane_coefficients,  // get_const(index) function pointer
    get_function__Edge__plane_coefficients,  // get(index) function pointer
    fetch_function__Edge__plane_coefficients,  // fetch(index, &value) function pointer
    assign_function__Edge__plane_coefficients,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "plane_information_matrix",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_DOUBLE,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    true,  // is array
    9,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, plane_information_matrix),  // bytes offset in struct
    nullptr,  // default value
    size_function__Edge__plane_information_matrix,  // size() function pointer
    get_const_function__Edge__plane_information_matrix,  // get_const(index) function pointer
    get_function__Edge__plane_information_matrix,  // get(index) function pointer
    fetch_function__Edge__plane_information_matrix,  // fetch(index, &value) function pointer
    assign_function__Edge__plane_information_matrix,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "information_matrix",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Float64MultiArray>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, information_matrix),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "measurement_transform",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<geometry_msgs::msg::Transform>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, measurement_transform),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "attributes",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<situational_graphs_reasoning_msgs::msg::Attribute>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::Edge, attributes),  // bytes offset in struct
    nullptr,  // default value
    size_function__Edge__attributes,  // size() function pointer
    get_const_function__Edge__attributes,  // get_const(index) function pointer
    get_function__Edge__attributes,  // get(index) function pointer
    fetch_function__Edge__attributes,  // fetch(index, &value) function pointer
    assign_function__Edge__attributes,  // assign(index, value) function pointer
    resize_function__Edge__attributes  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers Edge_message_members = {
  "situational_graphs_reasoning_msgs::msg",  // message namespace
  "Edge",  // message name
  8,  // number of fields
  sizeof(situational_graphs_reasoning_msgs::msg::Edge),
  Edge_message_member_array,  // message members
  Edge_init_function,  // function to initialize message memory (memory has to be allocated)
  Edge_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t Edge_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &Edge_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<situational_graphs_reasoning_msgs::msg::Edge>()
{
  return &::situational_graphs_reasoning_msgs::msg::rosidl_typesupport_introspection_cpp::Edge_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, situational_graphs_reasoning_msgs, msg, Edge)() {
  return &::situational_graphs_reasoning_msgs::msg::rosidl_typesupport_introspection_cpp::Edge_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
