// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Graph.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__GRAPH__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__GRAPH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'nodes'
#include "situational_graphs_reasoning_msgs/msg/detail/node__struct.hpp"
// Member 'edges'
#include "situational_graphs_reasoning_msgs/msg/detail/edge__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Graph __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Graph __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Graph_
{
  using Type = Graph_<ContainerAllocator>;

  explicit Graph_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
    }
  }

  explicit Graph_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _nodes_type =
    std::vector<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>>;
  _nodes_type nodes;
  using _edges_type =
    std::vector<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>>;
  _edges_type edges;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__nodes(
    const std::vector<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>> & _arg)
  {
    this->nodes = _arg;
    return *this;
  }
  Type & set__edges(
    const std::vector<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Edge_<ContainerAllocator>>> & _arg)
  {
    this->edges = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Graph
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Graph
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Graph_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->nodes != other.nodes) {
      return false;
    }
    if (this->edges != other.edges) {
      return false;
    }
    return true;
  }
  bool operator!=(const Graph_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Graph_

// alias to use template instance with default allocator
using Graph =
  situational_graphs_reasoning_msgs::msg::Graph_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__GRAPH__STRUCT_HPP_
