// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/GraphKeyframes.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__GRAPH_KEYFRAMES__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__GRAPH_KEYFRAMES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_reasoning_msgs/msg/detail/graph_keyframes__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'keyframes'
#include "situational_graphs_reasoning_msgs/msg/detail/keyframe__traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GraphKeyframes & msg,
  std::ostream & out)
{
  out << "{";
  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: robot
  {
    out << "robot: ";
    rosidl_generator_traits::value_to_yaml(msg.robot, out);
    out << ", ";
  }

  // member: keyframes
  {
    if (msg.keyframes.size() == 0) {
      out << "keyframes: []";
    } else {
      out << "keyframes: [";
      size_t pending_items = msg.keyframes.size();
      for (auto item : msg.keyframes) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GraphKeyframes & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: robot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot: ";
    rosidl_generator_traits::value_to_yaml(msg.robot, out);
    out << "\n";
  }

  // member: keyframes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.keyframes.size() == 0) {
      out << "keyframes: []\n";
    } else {
      out << "keyframes:\n";
      for (auto item : msg.keyframes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GraphKeyframes & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::msg::GraphKeyframes & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::msg::GraphKeyframes & msg)
{
  return situational_graphs_reasoning_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::msg::GraphKeyframes>()
{
  return "situational_graphs_reasoning_msgs::msg::GraphKeyframes";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::msg::GraphKeyframes>()
{
  return "situational_graphs_reasoning_msgs/msg/GraphKeyframes";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::msg::GraphKeyframes>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::msg::GraphKeyframes>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::msg::GraphKeyframes>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__GRAPH_KEYFRAMES__TRAITS_HPP_
