// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Keyframe.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__KEYFRAME__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__KEYFRAME__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_reasoning_msgs/msg/detail/keyframe__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'pointcloud'
#include "sensor_msgs/msg/detail/point_cloud2__traits.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Keyframe & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: pointcloud
  {
    out << "pointcloud: ";
    to_flow_style_yaml(msg.pointcloud, out);
    out << ", ";
  }

  // member: pose
  {
    out << "pose: ";
    to_flow_style_yaml(msg.pose, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Keyframe & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: pointcloud
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pointcloud:\n";
    to_block_style_yaml(msg.pointcloud, out, indentation + 2);
  }

  // member: pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose:\n";
    to_block_style_yaml(msg.pose, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Keyframe & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::msg::Keyframe & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::msg::Keyframe & msg)
{
  return situational_graphs_reasoning_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::msg::Keyframe>()
{
  return "situational_graphs_reasoning_msgs::msg::Keyframe";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::msg::Keyframe>()
{
  return "situational_graphs_reasoning_msgs/msg/Keyframe";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::msg::Keyframe>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::msg::Keyframe>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::msg::Keyframe>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__KEYFRAME__TRAITS_HPP_
