// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_reasoning_msgs:msg/Node.idl
// generated code does not contain a copyright notice
#include "situational_graphs_reasoning_msgs/msg/detail/node__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `type`
#include "rosidl_runtime_c/string_functions.h"
// Member `attributes`
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__functions.h"

bool
situational_graphs_reasoning_msgs__msg__Node__init(situational_graphs_reasoning_msgs__msg__Node * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // type
  if (!rosidl_runtime_c__String__init(&msg->type)) {
    situational_graphs_reasoning_msgs__msg__Node__fini(msg);
    return false;
  }
  // attributes
  if (!situational_graphs_reasoning_msgs__msg__Attribute__Sequence__init(&msg->attributes, 0)) {
    situational_graphs_reasoning_msgs__msg__Node__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Node__fini(situational_graphs_reasoning_msgs__msg__Node * msg)
{
  if (!msg) {
    return;
  }
  // id
  // type
  rosidl_runtime_c__String__fini(&msg->type);
  // attributes
  situational_graphs_reasoning_msgs__msg__Attribute__Sequence__fini(&msg->attributes);
}

bool
situational_graphs_reasoning_msgs__msg__Node__are_equal(const situational_graphs_reasoning_msgs__msg__Node * lhs, const situational_graphs_reasoning_msgs__msg__Node * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // type
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // attributes
  if (!situational_graphs_reasoning_msgs__msg__Attribute__Sequence__are_equal(
      &(lhs->attributes), &(rhs->attributes)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Node__copy(
  const situational_graphs_reasoning_msgs__msg__Node * input,
  situational_graphs_reasoning_msgs__msg__Node * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // type
  if (!rosidl_runtime_c__String__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // attributes
  if (!situational_graphs_reasoning_msgs__msg__Attribute__Sequence__copy(
      &(input->attributes), &(output->attributes)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__msg__Node *
situational_graphs_reasoning_msgs__msg__Node__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Node * msg = (situational_graphs_reasoning_msgs__msg__Node *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Node), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__msg__Node));
  bool success = situational_graphs_reasoning_msgs__msg__Node__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__msg__Node__destroy(situational_graphs_reasoning_msgs__msg__Node * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__msg__Node__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__msg__Node__Sequence__init(situational_graphs_reasoning_msgs__msg__Node__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Node * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__msg__Node *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__msg__Node), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__msg__Node__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__msg__Node__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Node__Sequence__fini(situational_graphs_reasoning_msgs__msg__Node__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__msg__Node__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__msg__Node__Sequence *
situational_graphs_reasoning_msgs__msg__Node__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Node__Sequence * array = (situational_graphs_reasoning_msgs__msg__Node__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Node__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__msg__Node__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__msg__Node__Sequence__destroy(situational_graphs_reasoning_msgs__msg__Node__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__msg__Node__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__msg__Node__Sequence__are_equal(const situational_graphs_reasoning_msgs__msg__Node__Sequence * lhs, const situational_graphs_reasoning_msgs__msg__Node__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Node__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Node__Sequence__copy(
  const situational_graphs_reasoning_msgs__msg__Node__Sequence * input,
  situational_graphs_reasoning_msgs__msg__Node__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__msg__Node);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__msg__Node * data =
      (situational_graphs_reasoning_msgs__msg__Node *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__msg__Node__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__msg__Node__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Node__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
