// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Node.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__NODE__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__NODE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'attributes'
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Node __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Node __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Node_
{
  using Type = Node_<ContainerAllocator>;

  explicit Node_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->type = "";
    }
  }

  explicit Node_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : type(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->type = "";
    }
  }

  // field types and members
  using _id_type =
    int32_t;
  _id_type id;
  using _type_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _type_type type;
  using _attributes_type =
    std::vector<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>>;
  _attributes_type attributes;

  // setters for named parameter idiom
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__type(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__attributes(
    const std::vector<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>> & _arg)
  {
    this->attributes = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Node
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Node
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Node_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Node_ & other) const
  {
    if (this->id != other.id) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->attributes != other.attributes) {
      return false;
    }
    return true;
  }
  bool operator!=(const Node_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Node_

// alias to use template instance with default allocator
using Node =
  situational_graphs_reasoning_msgs::msg::Node_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__NODE__STRUCT_HPP_
