// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_reasoning_msgs:msg/RoomKeyframe.idl
// generated code does not contain a copyright notice
#include "situational_graphs_reasoning_msgs/msg/detail/room_keyframe__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pointcloud`
#include "sensor_msgs/msg/detail/point_cloud2__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `keyframes_ids`
// Member `planes_ids`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__init(situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(msg);
    return false;
  }
  // id
  // pointcloud
  if (!sensor_msgs__msg__PointCloud2__init(&msg->pointcloud)) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(msg);
    return false;
  }
  // keyframes_ids
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->keyframes_ids, 0)) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(msg);
    return false;
  }
  // planes_ids
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->planes_ids, 0)) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  // pointcloud
  sensor_msgs__msg__PointCloud2__fini(&msg->pointcloud);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // keyframes_ids
  rosidl_runtime_c__int32__Sequence__fini(&msg->keyframes_ids);
  // planes_ids
  rosidl_runtime_c__int32__Sequence__fini(&msg->planes_ids);
}

bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__are_equal(const situational_graphs_reasoning_msgs__msg__RoomKeyframe * lhs, const situational_graphs_reasoning_msgs__msg__RoomKeyframe * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // pointcloud
  if (!sensor_msgs__msg__PointCloud2__are_equal(
      &(lhs->pointcloud), &(rhs->pointcloud)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // keyframes_ids
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->keyframes_ids), &(rhs->keyframes_ids)))
  {
    return false;
  }
  // planes_ids
  if (!rosidl_runtime_c__int32__Sequence__are_equal(
      &(lhs->planes_ids), &(rhs->planes_ids)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__copy(
  const situational_graphs_reasoning_msgs__msg__RoomKeyframe * input,
  situational_graphs_reasoning_msgs__msg__RoomKeyframe * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // pointcloud
  if (!sensor_msgs__msg__PointCloud2__copy(
      &(input->pointcloud), &(output->pointcloud)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // keyframes_ids
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->keyframes_ids), &(output->keyframes_ids)))
  {
    return false;
  }
  // planes_ids
  if (!rosidl_runtime_c__int32__Sequence__copy(
      &(input->planes_ids), &(output->planes_ids)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__msg__RoomKeyframe *
situational_graphs_reasoning_msgs__msg__RoomKeyframe__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg = (situational_graphs_reasoning_msgs__msg__RoomKeyframe *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__RoomKeyframe), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__msg__RoomKeyframe));
  bool success = situational_graphs_reasoning_msgs__msg__RoomKeyframe__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__destroy(situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__init(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__RoomKeyframe * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__msg__RoomKeyframe *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__msg__RoomKeyframe), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__msg__RoomKeyframe__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__fini(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence *
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array = (situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__destroy(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__are_equal(const situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * lhs, const situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__RoomKeyframe__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__copy(
  const situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * input,
  situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__msg__RoomKeyframe);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__msg__RoomKeyframe * data =
      (situational_graphs_reasoning_msgs__msg__RoomKeyframe *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__msg__RoomKeyframe__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__RoomKeyframe__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
