// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/RoomKeyframe.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ROOM_KEYFRAME__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ROOM_KEYFRAME__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'pointcloud'
#include "sensor_msgs/msg/detail/point_cloud2__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__RoomKeyframe __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__RoomKeyframe __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoomKeyframe_
{
  using Type = RoomKeyframe_<ContainerAllocator>;

  explicit RoomKeyframe_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    pointcloud(_init),
    pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  explicit RoomKeyframe_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    pointcloud(_alloc, _init),
    pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _pointcloud_type =
    sensor_msgs::msg::PointCloud2_<ContainerAllocator>;
  _pointcloud_type pointcloud;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _keyframes_ids_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _keyframes_ids_type keyframes_ids;
  using _planes_ids_type =
    std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>>;
  _planes_ids_type planes_ids;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__pointcloud(
    const sensor_msgs::msg::PointCloud2_<ContainerAllocator> & _arg)
  {
    this->pointcloud = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__keyframes_ids(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->keyframes_ids = _arg;
    return *this;
  }
  Type & set__planes_ids(
    const std::vector<int32_t, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<int32_t>> & _arg)
  {
    this->planes_ids = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__RoomKeyframe
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__RoomKeyframe
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::RoomKeyframe_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoomKeyframe_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->pointcloud != other.pointcloud) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->keyframes_ids != other.keyframes_ids) {
      return false;
    }
    if (this->planes_ids != other.planes_ids) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoomKeyframe_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoomKeyframe_

// alias to use template instance with default allocator
using RoomKeyframe =
  situational_graphs_reasoning_msgs::msg::RoomKeyframe_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ROOM_KEYFRAME__STRUCT_HPP_
