// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_reasoning_msgs:srv/SubgraphMatch.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__SRV__DETAIL__SUBGRAPH_MATCH__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__SRV__DETAIL__SUBGRAPH_MATCH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SubgraphMatch_Request_
{
  using Type = SubgraphMatch_Request_<ContainerAllocator>;

  explicit SubgraphMatch_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->base_graph = "";
      this->target_graph = "";
    }
  }

  explicit SubgraphMatch_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : base_graph(_alloc),
    target_graph(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->base_graph = "";
      this->target_graph = "";
    }
  }

  // field types and members
  using _base_graph_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _base_graph_type base_graph;
  using _target_graph_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _target_graph_type target_graph;

  // setters for named parameter idiom
  Type & set__base_graph(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->base_graph = _arg;
    return *this;
  }
  Type & set__target_graph(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->target_graph = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SubgraphMatch_Request_ & other) const
  {
    if (this->base_graph != other.base_graph) {
      return false;
    }
    if (this->target_graph != other.target_graph) {
      return false;
    }
    return true;
  }
  bool operator!=(const SubgraphMatch_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SubgraphMatch_Request_

// alias to use template instance with default allocator
using SubgraphMatch_Request =
  situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace situational_graphs_reasoning_msgs


// Include directives for member types
// Member 'matches'
#include "situational_graphs_reasoning_msgs/msg/detail/graph__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SubgraphMatch_Response_
{
  using Type = SubgraphMatch_Response_<ContainerAllocator>;

  explicit SubgraphMatch_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = 0l;
    }
  }

  explicit SubgraphMatch_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = 0l;
    }
  }

  // field types and members
  using _success_type =
    int32_t;
  _success_type success;
  using _matches_type =
    std::vector<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>>;
  _matches_type matches;
  using _score_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _score_type score;

  // setters for named parameter idiom
  Type & set__success(
    const int32_t & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__matches(
    const std::vector<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<situational_graphs_reasoning_msgs::msg::Graph_<ContainerAllocator>>> & _arg)
  {
    this->matches = _arg;
    return *this;
  }
  Type & set__score(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->score = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response
    std::shared_ptr<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SubgraphMatch_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->matches != other.matches) {
      return false;
    }
    if (this->score != other.score) {
      return false;
    }
    return true;
  }
  bool operator!=(const SubgraphMatch_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SubgraphMatch_Response_

// alias to use template instance with default allocator
using SubgraphMatch_Response =
  situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace situational_graphs_reasoning_msgs

namespace situational_graphs_reasoning_msgs
{

namespace srv
{

struct SubgraphMatch
{
  using Request = situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request;
  using Response = situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response;
};

}  // namespace srv

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__SRV__DETAIL__SUBGRAPH_MATCH__STRUCT_HPP_
