// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_reasoning_msgs:msg/Attribute.idl
// generated code does not contain a copyright notice
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
// Member `str_value`
#include "rosidl_runtime_c/string_functions.h"
// Member `fl_value`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
situational_graphs_reasoning_msgs__msg__Attribute__init(situational_graphs_reasoning_msgs__msg__Attribute * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    situational_graphs_reasoning_msgs__msg__Attribute__fini(msg);
    return false;
  }
  // str_value
  if (!rosidl_runtime_c__String__init(&msg->str_value)) {
    situational_graphs_reasoning_msgs__msg__Attribute__fini(msg);
    return false;
  }
  // fl_value
  if (!rosidl_runtime_c__double__Sequence__init(&msg->fl_value, 0)) {
    situational_graphs_reasoning_msgs__msg__Attribute__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Attribute__fini(situational_graphs_reasoning_msgs__msg__Attribute * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // str_value
  rosidl_runtime_c__String__fini(&msg->str_value);
  // fl_value
  rosidl_runtime_c__double__Sequence__fini(&msg->fl_value);
}

bool
situational_graphs_reasoning_msgs__msg__Attribute__are_equal(const situational_graphs_reasoning_msgs__msg__Attribute * lhs, const situational_graphs_reasoning_msgs__msg__Attribute * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // str_value
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->str_value), &(rhs->str_value)))
  {
    return false;
  }
  // fl_value
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->fl_value), &(rhs->fl_value)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Attribute__copy(
  const situational_graphs_reasoning_msgs__msg__Attribute * input,
  situational_graphs_reasoning_msgs__msg__Attribute * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // str_value
  if (!rosidl_runtime_c__String__copy(
      &(input->str_value), &(output->str_value)))
  {
    return false;
  }
  // fl_value
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->fl_value), &(output->fl_value)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__msg__Attribute *
situational_graphs_reasoning_msgs__msg__Attribute__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Attribute * msg = (situational_graphs_reasoning_msgs__msg__Attribute *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Attribute), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__msg__Attribute));
  bool success = situational_graphs_reasoning_msgs__msg__Attribute__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__msg__Attribute__destroy(situational_graphs_reasoning_msgs__msg__Attribute * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__msg__Attribute__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__msg__Attribute__Sequence__init(situational_graphs_reasoning_msgs__msg__Attribute__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Attribute * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__msg__Attribute *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__msg__Attribute), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__msg__Attribute__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__msg__Attribute__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Attribute__Sequence__fini(situational_graphs_reasoning_msgs__msg__Attribute__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__msg__Attribute__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__msg__Attribute__Sequence *
situational_graphs_reasoning_msgs__msg__Attribute__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Attribute__Sequence * array = (situational_graphs_reasoning_msgs__msg__Attribute__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Attribute__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__msg__Attribute__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__msg__Attribute__Sequence__destroy(situational_graphs_reasoning_msgs__msg__Attribute__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__msg__Attribute__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__msg__Attribute__Sequence__are_equal(const situational_graphs_reasoning_msgs__msg__Attribute__Sequence * lhs, const situational_graphs_reasoning_msgs__msg__Attribute__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Attribute__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Attribute__Sequence__copy(
  const situational_graphs_reasoning_msgs__msg__Attribute__Sequence * input,
  situational_graphs_reasoning_msgs__msg__Attribute__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__msg__Attribute);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__msg__Attribute * data =
      (situational_graphs_reasoning_msgs__msg__Attribute *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__msg__Attribute__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__msg__Attribute__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Attribute__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
