// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Attribute.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ATTRIBUTE__STRUCT_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ATTRIBUTE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Attribute __attribute__((deprecated))
#else
# define DEPRECATED__situational_graphs_reasoning_msgs__msg__Attribute __declspec(deprecated)
#endif

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Attribute_
{
  using Type = Attribute_<ContainerAllocator>;

  explicit Attribute_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->str_value = "";
    }
  }

  explicit Attribute_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc),
    str_value(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->str_value = "";
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _str_value_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _str_value_type str_value;
  using _fl_value_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _fl_value_type fl_value;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__str_value(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->str_value = _arg;
    return *this;
  }
  Type & set__fl_value(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->fl_value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator> *;
  using ConstRawPtr =
    const situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Attribute
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__situational_graphs_reasoning_msgs__msg__Attribute
    std::shared_ptr<situational_graphs_reasoning_msgs::msg::Attribute_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Attribute_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->str_value != other.str_value) {
      return false;
    }
    if (this->fl_value != other.fl_value) {
      return false;
    }
    return true;
  }
  bool operator!=(const Attribute_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Attribute_

// alias to use template instance with default allocator
using Attribute =
  situational_graphs_reasoning_msgs::msg::Attribute_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ATTRIBUTE__STRUCT_HPP_
