// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__BUILDER_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "situational_graphs_reasoning_msgs/msg/detail/edge__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace situational_graphs_reasoning_msgs
{

namespace msg
{

namespace builder
{

class Init_Edge_attributes
{
public:
  explicit Init_Edge_attributes(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  ::situational_graphs_reasoning_msgs::msg::Edge attributes(::situational_graphs_reasoning_msgs::msg::Edge::_attributes_type arg)
  {
    msg_.attributes = std::move(arg);
    return std::move(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_measurement_transform
{
public:
  explicit Init_Edge_measurement_transform(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  Init_Edge_attributes measurement_transform(::situational_graphs_reasoning_msgs::msg::Edge::_measurement_transform_type arg)
  {
    msg_.measurement_transform = std::move(arg);
    return Init_Edge_attributes(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_information_matrix
{
public:
  explicit Init_Edge_information_matrix(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  Init_Edge_measurement_transform information_matrix(::situational_graphs_reasoning_msgs::msg::Edge::_information_matrix_type arg)
  {
    msg_.information_matrix = std::move(arg);
    return Init_Edge_measurement_transform(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_plane_information_matrix
{
public:
  explicit Init_Edge_plane_information_matrix(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  Init_Edge_information_matrix plane_information_matrix(::situational_graphs_reasoning_msgs::msg::Edge::_plane_information_matrix_type arg)
  {
    msg_.plane_information_matrix = std::move(arg);
    return Init_Edge_information_matrix(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_plane_coefficients
{
public:
  explicit Init_Edge_plane_coefficients(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  Init_Edge_plane_information_matrix plane_coefficients(::situational_graphs_reasoning_msgs::msg::Edge::_plane_coefficients_type arg)
  {
    msg_.plane_coefficients = std::move(arg);
    return Init_Edge_plane_information_matrix(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_edge_id
{
public:
  explicit Init_Edge_edge_id(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  Init_Edge_plane_coefficients edge_id(::situational_graphs_reasoning_msgs::msg::Edge::_edge_id_type arg)
  {
    msg_.edge_id = std::move(arg);
    return Init_Edge_plane_coefficients(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_target_node
{
public:
  explicit Init_Edge_target_node(::situational_graphs_reasoning_msgs::msg::Edge & msg)
  : msg_(msg)
  {}
  Init_Edge_edge_id target_node(::situational_graphs_reasoning_msgs::msg::Edge::_target_node_type arg)
  {
    msg_.target_node = std::move(arg);
    return Init_Edge_edge_id(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

class Init_Edge_origin_node
{
public:
  Init_Edge_origin_node()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_Edge_target_node origin_node(::situational_graphs_reasoning_msgs::msg::Edge::_origin_node_type arg)
  {
    msg_.origin_node = std::move(arg);
    return Init_Edge_target_node(msg_);
  }

private:
  ::situational_graphs_reasoning_msgs::msg::Edge msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::situational_graphs_reasoning_msgs::msg::Edge>()
{
  return situational_graphs_reasoning_msgs::msg::builder::Init_Edge_origin_node();
}

}  // namespace situational_graphs_reasoning_msgs

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__BUILDER_HPP_
