// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_reasoning_msgs:msg/Edge.idl
// generated code does not contain a copyright notice
#include "situational_graphs_reasoning_msgs/msg/detail/edge__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `information_matrix`
#include "std_msgs/msg/detail/float64_multi_array__functions.h"
// Member `measurement_transform`
#include "geometry_msgs/msg/detail/transform__functions.h"
// Member `attributes`
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__functions.h"

bool
situational_graphs_reasoning_msgs__msg__Edge__init(situational_graphs_reasoning_msgs__msg__Edge * msg)
{
  if (!msg) {
    return false;
  }
  // origin_node
  // target_node
  // edge_id
  // plane_coefficients
  // plane_information_matrix
  // information_matrix
  if (!std_msgs__msg__Float64MultiArray__init(&msg->information_matrix)) {
    situational_graphs_reasoning_msgs__msg__Edge__fini(msg);
    return false;
  }
  // measurement_transform
  if (!geometry_msgs__msg__Transform__init(&msg->measurement_transform)) {
    situational_graphs_reasoning_msgs__msg__Edge__fini(msg);
    return false;
  }
  // attributes
  if (!situational_graphs_reasoning_msgs__msg__Attribute__Sequence__init(&msg->attributes, 0)) {
    situational_graphs_reasoning_msgs__msg__Edge__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Edge__fini(situational_graphs_reasoning_msgs__msg__Edge * msg)
{
  if (!msg) {
    return;
  }
  // origin_node
  // target_node
  // edge_id
  // plane_coefficients
  // plane_information_matrix
  // information_matrix
  std_msgs__msg__Float64MultiArray__fini(&msg->information_matrix);
  // measurement_transform
  geometry_msgs__msg__Transform__fini(&msg->measurement_transform);
  // attributes
  situational_graphs_reasoning_msgs__msg__Attribute__Sequence__fini(&msg->attributes);
}

bool
situational_graphs_reasoning_msgs__msg__Edge__are_equal(const situational_graphs_reasoning_msgs__msg__Edge * lhs, const situational_graphs_reasoning_msgs__msg__Edge * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // origin_node
  if (lhs->origin_node != rhs->origin_node) {
    return false;
  }
  // target_node
  if (lhs->target_node != rhs->target_node) {
    return false;
  }
  // edge_id
  if (lhs->edge_id != rhs->edge_id) {
    return false;
  }
  // plane_coefficients
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->plane_coefficients[i] != rhs->plane_coefficients[i]) {
      return false;
    }
  }
  // plane_information_matrix
  for (size_t i = 0; i < 9; ++i) {
    if (lhs->plane_information_matrix[i] != rhs->plane_information_matrix[i]) {
      return false;
    }
  }
  // information_matrix
  if (!std_msgs__msg__Float64MultiArray__are_equal(
      &(lhs->information_matrix), &(rhs->information_matrix)))
  {
    return false;
  }
  // measurement_transform
  if (!geometry_msgs__msg__Transform__are_equal(
      &(lhs->measurement_transform), &(rhs->measurement_transform)))
  {
    return false;
  }
  // attributes
  if (!situational_graphs_reasoning_msgs__msg__Attribute__Sequence__are_equal(
      &(lhs->attributes), &(rhs->attributes)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Edge__copy(
  const situational_graphs_reasoning_msgs__msg__Edge * input,
  situational_graphs_reasoning_msgs__msg__Edge * output)
{
  if (!input || !output) {
    return false;
  }
  // origin_node
  output->origin_node = input->origin_node;
  // target_node
  output->target_node = input->target_node;
  // edge_id
  output->edge_id = input->edge_id;
  // plane_coefficients
  for (size_t i = 0; i < 4; ++i) {
    output->plane_coefficients[i] = input->plane_coefficients[i];
  }
  // plane_information_matrix
  for (size_t i = 0; i < 9; ++i) {
    output->plane_information_matrix[i] = input->plane_information_matrix[i];
  }
  // information_matrix
  if (!std_msgs__msg__Float64MultiArray__copy(
      &(input->information_matrix), &(output->information_matrix)))
  {
    return false;
  }
  // measurement_transform
  if (!geometry_msgs__msg__Transform__copy(
      &(input->measurement_transform), &(output->measurement_transform)))
  {
    return false;
  }
  // attributes
  if (!situational_graphs_reasoning_msgs__msg__Attribute__Sequence__copy(
      &(input->attributes), &(output->attributes)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__msg__Edge *
situational_graphs_reasoning_msgs__msg__Edge__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Edge * msg = (situational_graphs_reasoning_msgs__msg__Edge *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Edge), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__msg__Edge));
  bool success = situational_graphs_reasoning_msgs__msg__Edge__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__msg__Edge__destroy(situational_graphs_reasoning_msgs__msg__Edge * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__msg__Edge__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__msg__Edge__Sequence__init(situational_graphs_reasoning_msgs__msg__Edge__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Edge * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__msg__Edge *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__msg__Edge), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__msg__Edge__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__msg__Edge__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Edge__Sequence__fini(situational_graphs_reasoning_msgs__msg__Edge__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__msg__Edge__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__msg__Edge__Sequence *
situational_graphs_reasoning_msgs__msg__Edge__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Edge__Sequence * array = (situational_graphs_reasoning_msgs__msg__Edge__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Edge__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__msg__Edge__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__msg__Edge__Sequence__destroy(situational_graphs_reasoning_msgs__msg__Edge__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__msg__Edge__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__msg__Edge__Sequence__are_equal(const situational_graphs_reasoning_msgs__msg__Edge__Sequence * lhs, const situational_graphs_reasoning_msgs__msg__Edge__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Edge__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Edge__Sequence__copy(
  const situational_graphs_reasoning_msgs__msg__Edge__Sequence * input,
  situational_graphs_reasoning_msgs__msg__Edge__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__msg__Edge);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__msg__Edge * data =
      (situational_graphs_reasoning_msgs__msg__Edge *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__msg__Edge__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__msg__Edge__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Edge__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
