// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from situational_graphs_reasoning_msgs:msg/Edge.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__STRUCT_H_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'information_matrix'
#include "std_msgs/msg/detail/float64_multi_array__struct.h"
// Member 'measurement_transform'
#include "geometry_msgs/msg/detail/transform__struct.h"
// Member 'attributes'
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__struct.h"

/// Struct defined in msg/Edge in the package situational_graphs_reasoning_msgs.
typedef struct situational_graphs_reasoning_msgs__msg__Edge
{
  int64_t origin_node;
  int64_t target_node;
  int64_t edge_id;
  double plane_coefficients[4];
  double plane_information_matrix[9];
  std_msgs__msg__Float64MultiArray information_matrix;
  geometry_msgs__msg__Transform measurement_transform;
  situational_graphs_reasoning_msgs__msg__Attribute__Sequence attributes;
} situational_graphs_reasoning_msgs__msg__Edge;

// Struct for a sequence of situational_graphs_reasoning_msgs__msg__Edge.
typedef struct situational_graphs_reasoning_msgs__msg__Edge__Sequence
{
  situational_graphs_reasoning_msgs__msg__Edge * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} situational_graphs_reasoning_msgs__msg__Edge__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__EDGE__STRUCT_H_
