// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from situational_graphs_reasoning_msgs:msg/GraphKeyframes.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "situational_graphs_reasoning_msgs/msg/detail/graph_keyframes__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void GraphKeyframes_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) situational_graphs_reasoning_msgs::msg::GraphKeyframes(_init);
}

void GraphKeyframes_fini_function(void * message_memory)
{
  auto typed_message = static_cast<situational_graphs_reasoning_msgs::msg::GraphKeyframes *>(message_memory);
  typed_message->~GraphKeyframes();
}

size_t size_function__GraphKeyframes__keyframes(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<situational_graphs_reasoning_msgs::msg::Keyframe> *>(untyped_member);
  return member->size();
}

const void * get_const_function__GraphKeyframes__keyframes(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<situational_graphs_reasoning_msgs::msg::Keyframe> *>(untyped_member);
  return &member[index];
}

void * get_function__GraphKeyframes__keyframes(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<situational_graphs_reasoning_msgs::msg::Keyframe> *>(untyped_member);
  return &member[index];
}

void fetch_function__GraphKeyframes__keyframes(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const situational_graphs_reasoning_msgs::msg::Keyframe *>(
    get_const_function__GraphKeyframes__keyframes(untyped_member, index));
  auto & value = *reinterpret_cast<situational_graphs_reasoning_msgs::msg::Keyframe *>(untyped_value);
  value = item;
}

void assign_function__GraphKeyframes__keyframes(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<situational_graphs_reasoning_msgs::msg::Keyframe *>(
    get_function__GraphKeyframes__keyframes(untyped_member, index));
  const auto & value = *reinterpret_cast<const situational_graphs_reasoning_msgs::msg::Keyframe *>(untyped_value);
  item = value;
}

void resize_function__GraphKeyframes__keyframes(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<situational_graphs_reasoning_msgs::msg::Keyframe> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember GraphKeyframes_message_member_array[3] = {
  {
    "type",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::GraphKeyframes, type),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "robot",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_STRING,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::GraphKeyframes, robot),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "keyframes",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<situational_graphs_reasoning_msgs::msg::Keyframe>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(situational_graphs_reasoning_msgs::msg::GraphKeyframes, keyframes),  // bytes offset in struct
    nullptr,  // default value
    size_function__GraphKeyframes__keyframes,  // size() function pointer
    get_const_function__GraphKeyframes__keyframes,  // get_const(index) function pointer
    get_function__GraphKeyframes__keyframes,  // get(index) function pointer
    fetch_function__GraphKeyframes__keyframes,  // fetch(index, &value) function pointer
    assign_function__GraphKeyframes__keyframes,  // assign(index, value) function pointer
    resize_function__GraphKeyframes__keyframes  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers GraphKeyframes_message_members = {
  "situational_graphs_reasoning_msgs::msg",  // message namespace
  "GraphKeyframes",  // message name
  3,  // number of fields
  sizeof(situational_graphs_reasoning_msgs::msg::GraphKeyframes),
  GraphKeyframes_message_member_array,  // message members
  GraphKeyframes_init_function,  // function to initialize message memory (memory has to be allocated)
  GraphKeyframes_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t GraphKeyframes_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &GraphKeyframes_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<situational_graphs_reasoning_msgs::msg::GraphKeyframes>()
{
  return &::situational_graphs_reasoning_msgs::msg::rosidl_typesupport_introspection_cpp::GraphKeyframes_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, situational_graphs_reasoning_msgs, msg, GraphKeyframes)() {
  return &::situational_graphs_reasoning_msgs::msg::rosidl_typesupport_introspection_cpp::GraphKeyframes_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
