// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_reasoning_msgs:msg/Match.idl
// generated code does not contain a copyright notice
#include "situational_graphs_reasoning_msgs/msg/detail/match__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
#include "rosidl_runtime_c/string_functions.h"
// Member `basis_nodes`
// Member `target_nodes`
#include "situational_graphs_reasoning_msgs/msg/detail/node__functions.h"
// Member `edges`
#include "situational_graphs_reasoning_msgs/msg/detail/edge__functions.h"

bool
situational_graphs_reasoning_msgs__msg__Match__init(situational_graphs_reasoning_msgs__msg__Match * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    situational_graphs_reasoning_msgs__msg__Match__fini(msg);
    return false;
  }
  // basis_nodes
  if (!situational_graphs_reasoning_msgs__msg__Node__Sequence__init(&msg->basis_nodes, 0)) {
    situational_graphs_reasoning_msgs__msg__Match__fini(msg);
    return false;
  }
  // target_nodes
  if (!situational_graphs_reasoning_msgs__msg__Node__Sequence__init(&msg->target_nodes, 0)) {
    situational_graphs_reasoning_msgs__msg__Match__fini(msg);
    return false;
  }
  // edges
  if (!situational_graphs_reasoning_msgs__msg__Edge__Sequence__init(&msg->edges, 0)) {
    situational_graphs_reasoning_msgs__msg__Match__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Match__fini(situational_graphs_reasoning_msgs__msg__Match * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // basis_nodes
  situational_graphs_reasoning_msgs__msg__Node__Sequence__fini(&msg->basis_nodes);
  // target_nodes
  situational_graphs_reasoning_msgs__msg__Node__Sequence__fini(&msg->target_nodes);
  // edges
  situational_graphs_reasoning_msgs__msg__Edge__Sequence__fini(&msg->edges);
}

bool
situational_graphs_reasoning_msgs__msg__Match__are_equal(const situational_graphs_reasoning_msgs__msg__Match * lhs, const situational_graphs_reasoning_msgs__msg__Match * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // basis_nodes
  if (!situational_graphs_reasoning_msgs__msg__Node__Sequence__are_equal(
      &(lhs->basis_nodes), &(rhs->basis_nodes)))
  {
    return false;
  }
  // target_nodes
  if (!situational_graphs_reasoning_msgs__msg__Node__Sequence__are_equal(
      &(lhs->target_nodes), &(rhs->target_nodes)))
  {
    return false;
  }
  // edges
  if (!situational_graphs_reasoning_msgs__msg__Edge__Sequence__are_equal(
      &(lhs->edges), &(rhs->edges)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Match__copy(
  const situational_graphs_reasoning_msgs__msg__Match * input,
  situational_graphs_reasoning_msgs__msg__Match * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // basis_nodes
  if (!situational_graphs_reasoning_msgs__msg__Node__Sequence__copy(
      &(input->basis_nodes), &(output->basis_nodes)))
  {
    return false;
  }
  // target_nodes
  if (!situational_graphs_reasoning_msgs__msg__Node__Sequence__copy(
      &(input->target_nodes), &(output->target_nodes)))
  {
    return false;
  }
  // edges
  if (!situational_graphs_reasoning_msgs__msg__Edge__Sequence__copy(
      &(input->edges), &(output->edges)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__msg__Match *
situational_graphs_reasoning_msgs__msg__Match__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Match * msg = (situational_graphs_reasoning_msgs__msg__Match *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Match), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__msg__Match));
  bool success = situational_graphs_reasoning_msgs__msg__Match__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__msg__Match__destroy(situational_graphs_reasoning_msgs__msg__Match * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__msg__Match__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__msg__Match__Sequence__init(situational_graphs_reasoning_msgs__msg__Match__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Match * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__msg__Match *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__msg__Match), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__msg__Match__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__msg__Match__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__msg__Match__Sequence__fini(situational_graphs_reasoning_msgs__msg__Match__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__msg__Match__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__msg__Match__Sequence *
situational_graphs_reasoning_msgs__msg__Match__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__msg__Match__Sequence * array = (situational_graphs_reasoning_msgs__msg__Match__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__msg__Match__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__msg__Match__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__msg__Match__Sequence__destroy(situational_graphs_reasoning_msgs__msg__Match__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__msg__Match__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__msg__Match__Sequence__are_equal(const situational_graphs_reasoning_msgs__msg__Match__Sequence * lhs, const situational_graphs_reasoning_msgs__msg__Match__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Match__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__msg__Match__Sequence__copy(
  const situational_graphs_reasoning_msgs__msg__Match__Sequence * input,
  situational_graphs_reasoning_msgs__msg__Match__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__msg__Match);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__msg__Match * data =
      (situational_graphs_reasoning_msgs__msg__Match *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__msg__Match__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__msg__Match__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__msg__Match__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
