// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_reasoning_msgs:msg/Node.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__NODE__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__NODE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_reasoning_msgs/msg/detail/node__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'attributes'
#include "situational_graphs_reasoning_msgs/msg/detail/attribute__traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Node & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: attributes
  {
    if (msg.attributes.size() == 0) {
      out << "attributes: []";
    } else {
      out << "attributes: [";
      size_t pending_items = msg.attributes.size();
      for (auto item : msg.attributes) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Node & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: attributes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.attributes.size() == 0) {
      out << "attributes: []\n";
    } else {
      out << "attributes:\n";
      for (auto item : msg.attributes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Node & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::msg::Node & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::msg::Node & msg)
{
  return situational_graphs_reasoning_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::msg::Node>()
{
  return "situational_graphs_reasoning_msgs::msg::Node";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::msg::Node>()
{
  return "situational_graphs_reasoning_msgs/msg/Node";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::msg::Node>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::msg::Node>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::msg::Node>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__NODE__TRAITS_HPP_
