// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from situational_graphs_reasoning_msgs:msg/RoomKeyframe.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ROOM_KEYFRAME__FUNCTIONS_H_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ROOM_KEYFRAME__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "situational_graphs_reasoning_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "situational_graphs_reasoning_msgs/msg/detail/room_keyframe__struct.h"

/// Initialize msg/RoomKeyframe message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe
 * )) before or use
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__init(situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg);

/// Finalize msg/RoomKeyframe message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini(situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg);

/// Create msg/RoomKeyframe message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
situational_graphs_reasoning_msgs__msg__RoomKeyframe *
situational_graphs_reasoning_msgs__msg__RoomKeyframe__create();

/// Destroy msg/RoomKeyframe message.
/**
 * It calls
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__destroy(situational_graphs_reasoning_msgs__msg__RoomKeyframe * msg);

/// Check for msg/RoomKeyframe message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__are_equal(const situational_graphs_reasoning_msgs__msg__RoomKeyframe * lhs, const situational_graphs_reasoning_msgs__msg__RoomKeyframe * rhs);

/// Copy a msg/RoomKeyframe message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__copy(
  const situational_graphs_reasoning_msgs__msg__RoomKeyframe * input,
  situational_graphs_reasoning_msgs__msg__RoomKeyframe * output);

/// Initialize array of msg/RoomKeyframe messages.
/**
 * It allocates the memory for the number of elements and calls
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__init(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array, size_t size);

/// Finalize array of msg/RoomKeyframe messages.
/**
 * It calls
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__fini(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array);

/// Create array of msg/RoomKeyframe messages.
/**
 * It allocates the memory for the array and calls
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence *
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__create(size_t size);

/// Destroy array of msg/RoomKeyframe messages.
/**
 * It calls
 * situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
void
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__destroy(situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * array);

/// Check for msg/RoomKeyframe message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__are_equal(const situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * lhs, const situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * rhs);

/// Copy an array of msg/RoomKeyframe messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_situational_graphs_reasoning_msgs
bool
situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence__copy(
  const situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * input,
  situational_graphs_reasoning_msgs__msg__RoomKeyframe__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__MSG__DETAIL__ROOM_KEYFRAME__FUNCTIONS_H_
