// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from situational_graphs_reasoning_msgs:srv/SubgraphMatch.idl
// generated code does not contain a copyright notice
#include "situational_graphs_reasoning_msgs/srv/detail/subgraph_match__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `base_graph`
// Member `target_graph`
#include "rosidl_runtime_c/string_functions.h"

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__init(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * msg)
{
  if (!msg) {
    return false;
  }
  // base_graph
  if (!rosidl_runtime_c__String__init(&msg->base_graph)) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(msg);
    return false;
  }
  // target_graph
  if (!rosidl_runtime_c__String__init(&msg->target_graph)) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * msg)
{
  if (!msg) {
    return;
  }
  // base_graph
  rosidl_runtime_c__String__fini(&msg->base_graph);
  // target_graph
  rosidl_runtime_c__String__fini(&msg->target_graph);
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__are_equal(const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * lhs, const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // base_graph
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->base_graph), &(rhs->base_graph)))
  {
    return false;
  }
  // target_graph
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->target_graph), &(rhs->target_graph)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__copy(
  const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * input,
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // base_graph
  if (!rosidl_runtime_c__String__copy(
      &(input->base_graph), &(output->base_graph)))
  {
    return false;
  }
  // target_graph
  if (!rosidl_runtime_c__String__copy(
      &(input->target_graph), &(output->target_graph)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request *
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * msg = (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request));
  bool success = situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__destroy(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__init(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__fini(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence *
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * array = (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__destroy(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__are_equal(const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * lhs, const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence__copy(
  const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * input,
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request * data =
      (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__srv__SubgraphMatch_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `matches`
#include "situational_graphs_reasoning_msgs/msg/detail/graph__functions.h"
// Member `score`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__init(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // matches
  if (!situational_graphs_reasoning_msgs__msg__Graph__Sequence__init(&msg->matches, 0)) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(msg);
    return false;
  }
  // score
  if (!rosidl_runtime_c__float__Sequence__init(&msg->score, 0)) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(msg);
    return false;
  }
  return true;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // matches
  situational_graphs_reasoning_msgs__msg__Graph__Sequence__fini(&msg->matches);
  // score
  rosidl_runtime_c__float__Sequence__fini(&msg->score);
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__are_equal(const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * lhs, const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // matches
  if (!situational_graphs_reasoning_msgs__msg__Graph__Sequence__are_equal(
      &(lhs->matches), &(rhs->matches)))
  {
    return false;
  }
  // score
  if (!rosidl_runtime_c__float__Sequence__are_equal(
      &(lhs->score), &(rhs->score)))
  {
    return false;
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__copy(
  const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * input,
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // matches
  if (!situational_graphs_reasoning_msgs__msg__Graph__Sequence__copy(
      &(input->matches), &(output->matches)))
  {
    return false;
  }
  // score
  if (!rosidl_runtime_c__float__Sequence__copy(
      &(input->score), &(output->score)))
  {
    return false;
  }
  return true;
}

situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response *
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * msg = (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response));
  bool success = situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__destroy(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__init(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * data = NULL;

  if (size) {
    data = (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response *)allocator.zero_allocate(size, sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__fini(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence *
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * array = (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence *)allocator.allocate(sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__destroy(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__are_equal(const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * lhs, const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence__copy(
  const situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * input,
  situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response * data =
      (situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!situational_graphs_reasoning_msgs__srv__SubgraphMatch_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
