// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from situational_graphs_reasoning_msgs:srv/SubgraphMatch.idl
// generated code does not contain a copyright notice

#ifndef SITUATIONAL_GRAPHS_REASONING_MSGS__SRV__DETAIL__SUBGRAPH_MATCH__TRAITS_HPP_
#define SITUATIONAL_GRAPHS_REASONING_MSGS__SRV__DETAIL__SUBGRAPH_MATCH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "situational_graphs_reasoning_msgs/srv/detail/subgraph_match__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SubgraphMatch_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: base_graph
  {
    out << "base_graph: ";
    rosidl_generator_traits::value_to_yaml(msg.base_graph, out);
    out << ", ";
  }

  // member: target_graph
  {
    out << "target_graph: ";
    rosidl_generator_traits::value_to_yaml(msg.target_graph, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SubgraphMatch_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: base_graph
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "base_graph: ";
    rosidl_generator_traits::value_to_yaml(msg.base_graph, out);
    out << "\n";
  }

  // member: target_graph
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target_graph: ";
    rosidl_generator_traits::value_to_yaml(msg.target_graph, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SubgraphMatch_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request & msg)
{
  return situational_graphs_reasoning_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>()
{
  return "situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>()
{
  return "situational_graphs_reasoning_msgs/srv/SubgraphMatch_Request";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'matches'
#include "situational_graphs_reasoning_msgs/msg/detail/graph__traits.hpp"

namespace situational_graphs_reasoning_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SubgraphMatch_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: matches
  {
    if (msg.matches.size() == 0) {
      out << "matches: []";
    } else {
      out << "matches: [";
      size_t pending_items = msg.matches.size();
      for (auto item : msg.matches) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: score
  {
    if (msg.score.size() == 0) {
      out << "score: []";
    } else {
      out << "score: [";
      size_t pending_items = msg.score.size();
      for (auto item : msg.score) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SubgraphMatch_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: matches
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.matches.size() == 0) {
      out << "matches: []\n";
    } else {
      out << "matches:\n";
      for (auto item : msg.matches) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: score
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.score.size() == 0) {
      out << "score: []\n";
    } else {
      out << "score:\n";
      for (auto item : msg.score) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SubgraphMatch_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace situational_graphs_reasoning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use situational_graphs_reasoning_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  situational_graphs_reasoning_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use situational_graphs_reasoning_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response & msg)
{
  return situational_graphs_reasoning_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>()
{
  return "situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>()
{
  return "situational_graphs_reasoning_msgs/srv/SubgraphMatch_Response";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<situational_graphs_reasoning_msgs::srv::SubgraphMatch>()
{
  return "situational_graphs_reasoning_msgs::srv::SubgraphMatch";
}

template<>
inline const char * name<situational_graphs_reasoning_msgs::srv::SubgraphMatch>()
{
  return "situational_graphs_reasoning_msgs/srv/SubgraphMatch";
}

template<>
struct has_fixed_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch>
  : std::integral_constant<
    bool,
    has_fixed_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>::value &&
    has_fixed_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>::value
  >
{
};

template<>
struct has_bounded_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch>
  : std::integral_constant<
    bool,
    has_bounded_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>::value &&
    has_bounded_size<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>::value
  >
{
};

template<>
struct is_service<situational_graphs_reasoning_msgs::srv::SubgraphMatch>
  : std::true_type
{
};

template<>
struct is_service_request<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Request>
  : std::true_type
{
};

template<>
struct is_service_response<situational_graphs_reasoning_msgs::srv::SubgraphMatch_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SITUATIONAL_GRAPHS_REASONING_MSGS__SRV__DETAIL__SUBGRAPH_MATCH__TRAITS_HPP_
